#!/usr/bin/perl
#SCORP Version 1.0 and WC Version 1.0
#scorp.cgi

require "./cgi-lib.pl";

#CGI-LIB
&ReadParse;

$search_word = $in{'d_01'};
$dir_name = $in{'d_02'};
$sort = $in{'d_03'};

%H_SORTING=("a_sort"=>"Ascending","d_sort"=>"Descending");

$max_chars = 60;

$FILE_NAME = 0;
$FREQUENCY = 1;
$INFO_NUM = 2;

$INFO_LINE = 0;
$INFO_WC = 1;
$INFO_POSITION = 2;
$INFO_WORD = 3;
$INFO_TEXT = 4;
$INFO_PARA = 5;

$MODE=0; #0: SCORP mode
#1: WC mode

$URL_SCORP_TOP = "../index_scorp.html";
$highlight = '#FF9999';

if($search_word eq ""){
	$title = 'Word Counter';
	$search_word = "[A-Za-z]+";
	$URL_SCORP = "./scorp.cgi?";
	$MODE = 1;
}else{
	$title = 'Selfish CORPus';
	$URL_SHOW = "./show.cgi?";
	$MODE = 0;
}

if ($sort eq ""){
	$sort = "d_sort";
#a_sort for ascending
#d_sort for descending
}

### Open Files and Construct ARRAYS
$file_n = 0;
@filename=split(/;/, $dir_name);
$nfilename=@filename;

if (($nfilename<2)&&(opendir(DIR, $dir_name))==1){###Read Directory to Search
	while ($file_name = readdir(DIR)){
		if($file_name ne '.' && $file_name ne '..'){
		if((open(IN, "$dir_name/$file_name"))!=1) {
			&CgiDie("Can't open the file: $file_name.");	
		}
		$files[$file_n][$FILE_NAME] = "$dir_name/$file_name";
		$files[$file_n][$INFO_NUM] = 0;
		$file_n++;
		close(IN);
		}
	}
}elsif($nfilename>1){
	for $fn (@filename){
		if((open(IN, "$fn"))!=1) {
			&CgiDie("Can't open the file: $fn");	
		}
		$files[$file_n][$FILE_NAME] = "$fn";
		$files[$file_n][$INFO_NUM] = 0;
		$file_n++;
		close(IN);
	}
}else{
	&CgiDie("Can't open the file or directory: $dir_name.")	
}

$counted_word = 0;
$checked_line = 0;

if($MODE==0){### SCORP mode
### Search Word
	$total = 0;
	$FILE_NUM = 0;

	while ($FILE_NUM < $file_n){
		$count = 1;
		$files[$FILE_NUM][$FREQUENCY] = 0;
		open(IN, "$files[$FILE_NUM][$FILE_NAME]");
		while (<IN>){
			$checked_line++;
			if (chomp($_) ne ' ' && /$search_word/){
				$position_head = 0;
				$position_toe = 0;
				$current_info_num = $files[$FILE_NUM][$INFO_NUM];
				$hitinfo[$FILE_NUM][$current_info_num][$INFO_WC] = 0;
				while (m/$search_word/g){
					$counted_word++;
					$arranged_text=$_;
					chomp $arranged_text;
					$files[$FILE_NUM][$FREQUENCY] = $count;
					$current_wc = $hitinfo[$FILE_NUM][$current_info_num][$INFO_WC];
					$hitinfo[$FILE_NUM][$current_info_num][$INFO_LINE] = $.;
					$hitinfo[$FILE_NUM][$current_info_num][$INFO_WORD]->[$current_wc] = $&;
					$position_head = index($_, $&, $position_toe);
					$position_toe = $position_head + length($&);
					$hitinfo[$FILE_NUM][$current_info_num][$INFO_POSITION]->[$current_wc] = $position_head;
					$bold_word = "<FONT Color=$highlight size=+1><b>$&</b></FONT>";
### Extract the Part of Sentence to Display
					$pre_match=$`;
					$post_match=$';
					$space="&nbsp;";
					$num_pre_post=int(($max_chars-length($&))/2);
					$num_pre_match=length($pre_match)-$num_pre_post;
					$num_post_match=length($post_match)-$num_pre_post;
					if($num_pre_match>=0){
						$pre_match=substr($pre_match,-$num_pre_post);
					}else{
						for($pre_space=0;$pre_space<abs($num_pre_match);$pre_space++){
							$pre_match=$space.$pre_match;
						}
					}

					if($num_post_match>=0){
						$post_match=substr($post_match,0,$num_pre_post);
					}else{
						for($post_space=0;$post_space<abs($num_post_match);$post_space++){
							$post_match=$post_match.$space;
						}
					}

					$arranged_text=$pre_match.$bold_word.$post_match;
					$hitinfo[$FILE_NUM][$current_info_num][$INFO_TEXT]->[$current_wc] = $arranged_text;	
					$count++;
					$total++;
					$files[$FILE_NUM][$INFO_NUM]++;
					$hitinfo[$FILE_NUM][$current_info_num][$INFO_WC]++;	
				}
			}
		}
		close(IN);
		$FILE_NUM++;
	}#while(file_num)
	$num = 0;
	$p = $q = $r = 0;
### Prepare Search Results for sorting
	while($p < $FILE_NUM){
		for ($q = 0; $q < $files[$p][$INFO_NUM]; $q++){
			for ($r = 0; $r < $hitinfo[$p][$q][$INFO_WC]; $r++){	
				$search_result = "$hitinfo[$p][$q][$INFO_WORD]->[$r]|@ "."$hitinfo[$p][$q][$INFO_TEXT]->[$r]|@ "."$hitinfo[$p][$q][$INFO_LINE]|@ "."$hitinfo[$p][$q][$INFO_POSITION]->[$r]|@ "."$files[$p][$FILE_NAME]";	
				push(@result, $search_result);
			}
		}
		$p++;
	}
### Sort the Result
	if ($sort eq 'a_sort'){### Sort the Result
		@sorted_result = sort byalpha_a @result;
	}else{ ###### 'd_sort'
		@sorted_result = sort byalpha_d @result;
	}
	&display_scorp
	&format_sorted_line_scorp(@sorted_result);
}else{### WC mode
### Count
	$FILE_NUM = 0;
	while ($FILE_NUM < $file_n){
		$files[$FILE_NUM][$FREQUENCY] = 0;
		open(IN, "$files[$FILE_NUM][$FILE_NAME]");
		while (<IN>){
			$checked_line++;
			while (m/$search_word/g){
				$word{$&}++;
				$counted_word++;
			}
		}
		close(IN);
		$FILE_NUM++;
	}
### Sort the Result
	if ($sort eq 'a_sort'){
		@keys = sort { $word{$a} <=> $word{$b} } keys %word;
	}else{ ### 'd_sort'
		@keys = sort { $word{$b} <=> $word{$a} } keys %word;
	}
	&display_wc
	&format_sorted_line_wc(@keys);
}

### Sub Functions 

### byalpha_a Sorting with Ascending Order
sub byalpha_a {
	(split(/\,/,$a))[0] cmp (split(/\,/,$b))[0]; 
}
### byalpha_d Sorting with Descending Order
sub byalpha_d {
	(split(/\,/,$b))[0] cmp (split(/\,/,$a))[0];
}

### Displaying the Result of SCORP: display_scorp
sub display_scorp {
	print "Content-type: text/html\n\n";
	print <<HTML_BODY;
<html>
<head>
<title>SCORP: Result</title>
<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP">
<meta name="Taka" content="SCORP@MISMED_AKITA-U">
<meta name="GENERATOR" content="vim">
<style type="text/css">
<!--
body{font size: 14px; text-align: center; font-family: helvetica,arial,sans-serif; color: rgb(112, 112, 255); background-color: rgb(250, 250, 255);}
a{text-decoration:underline;}
a:link{color:#0000FF;}
a:hover{color:#FFFFFF;background:#CCCCFF;}
a:active{color:#0000FF;}
a:visited{color:#9999FF;}
}
-->
</style>
</head>
<body>
<a href="$URL_SCORP_TOP">
<div style="text-align: right; font-size: xx-large;font-weight: bold; color: rgb(255,255,255); background-color: rgb(153,153,255)">
<br>
Selfish CORPus
<br><br>
</div>
</a>
<br>
<div style="text-align: left; font-size: large;">
Search Word: <b>$search_word</b><br>
Search Directory: <b>$dir_name</b><br>
Sort Option: <b>$H_SORTING{"$sort"}</b><br>
Found: <Font Color=$highlight size=+1><b>$counted_word</b></font><br>
Lines Searched: <b>$checked_line</b><br>
Files Searched: <b>$file_n</b><br>
</div>
<div style="text-align: left;margin-left: 40px;">
HTML_BODY
for ($i=0; $i<$file_n; $i++){
	print <<HTML_BODY;
$files[$i][$FILE_NAME]<br>
HTML_BODY
}
	print <<HTML_BODY;
</div>
<div style="text-align:center;font-weight:bold;">
<a href="$URL_SCORP_TOP">
Back to "Search" page
</a>
</div>
<hr>
<div style="text-align: right;">
Click the <B>"PARA"</B> button to see the paragraph.
</div>
<center>
<table border="2" cellspacing="2">
<caption>
<B>
SCORP Result
</B>
</caption>
<tbody>
<tr bgcolor="#7070e0">
<td width="50" align="center">
<span style="color: #FFFFFF; font-weight: bold">
ID
</span>
</td>
<td width="150" align="center">
<span style="color: #FFFFFF; font-weight: bold">
MATCH
</span>
</td>
<td align="center">
<span style="color: #FFFFFF; font-weight: bold">
SENTENCE
</span>
</td>
<td width="70" align="center; font-weight: bold">
&nbsp;
</td>
</tr>
HTML_BODY
}

### Displaying the Result of Word Counter: display_wc   ######
sub display_wc {
	print "Content-type: text/html\n\n";
print <<HTML_BODY;
<html>
<head>
<title>Word Coutner: Result</title>
<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP">
<meta name="Taka" content="SCORP@MISMED_AKITA-U">
<meta name="GENERATOR" content="vim">
<style type="text/css">
<!--
body{font size: 14px; text-align: center; font-family: helvetica,arial,sans-serif; color: rgb(112, 112, 255); background-color: rgb(255, 255, 255);}
a{text-decoration:none}
a:link{color:#0000ee}
a:visited{color:#551a8b}
a:active{color:#ff0000}
}
-->
</style>
</head>
<body>
<a href="$URL_SCORP_TOP">
<div style="text-align: right; font-size: xx-large;font-weight: bold; color: rgb(255,255,255); background-color: rgb(153,153,255)">
<br>
Word Counter
<br><br>
</div>
</a>
<br>
<div style="text-align: left; font-size: large;">
Search Word: <b>All Words</b><br>
Search Directory: <b>$dir_name</b><br>
Sort Option: <b>$H_SORTING{"$sort"}</b><br>
Found: <Font Color=$highlight size=+1><b>$counted_word</b></font><br>
Lines Searched: <b>$checked_line</b><br>
Files Searched: <b>$file_n</b><br>
</div>
<div style="text-align: left;margin-left: 40px;">
HTML_BODY
for ($i=0; $i<$file_n; $i++){
	print <<HTML_BODY;
$files[$i][$FILE_NAME]<br>
HTML_BODY
}
	print <<HTML_BODY;
</div>
<div style="text-align:center;font-weight:bold;">
<a href="$URL_SCORP_TOP">
Back to "Search" page
</a>
</div>
<hr>
<div style="text-align: right;">
Click the <B>"SEARCH"</B> button to search the word.
</div>
<center>
<table border="2" cellspacing="2">
<caption>
<B>
Word Counter Result
</B>
</caption>
<tbody>
<tr bgcolor="#7070e0">
<td width="50" align="center">
<span style="color: #FFFFFF; font-weight: bold">
ID
</span>
</td>
<td width="150" align="center">
<span style="color: #FFFFFF; font-weight: bold">
WORD
</span>
</td>
<td width="150" align="center">
<span style="color: #FFFFFF; font-weight: bold">
FREQUENCY
</span>
</td>
<td width="80" align="center">
&nbsp;
</td>
</tr>
HTML_BODY
}

### Output Search Result after Sorting: format_sorted_line_scorp   ######
sub format_sorted_line_scorp {
	$tr_bg_color=0;
	foreach $result_line (@_){
		$sorted_word = (split(/\|@ /,$result_line))[0];
		$sorted_text = (split(/\|@ /,$result_line))[1];
		$sorted_line = (split(/\|@ /,$result_line))[2];
		$sorted_position = (split(/\|@ /,$result_line))[3];
		$sorted_filename = (split(/\|@ /,$result_line))[4];
		$num++;
		if($num%2==1){
			$tr_bg_color="#ffffff";
			&html_body_scorp($tr_bg_color);
		}else{
			$tr_bg_color="#fgfgff";
			&html_body_scorp($tr_bg_color);
		}

	}
	if($num==0){
		&html_noresult;
	}
	&html_footer;
}

### Output Word Counter Result after Sorting: format_sorted_line_wc   ######
sub format_sorted_line_wc {
	$tr_bg_color=0;
	foreach (@keys){
		$wd=$_;
		$fq=$word{$_};
		$num++;
		if($num%2==1){
			$tr_bg_color="#ffffff";
			&html_body_wc($tr_bg_color);
		}else{
			$tr_bg_color="#fgfgff";
			&html_body_wc($tr_bg_color);
		}
	}
	&html_footer;
}

### Output SCORP BODY by HTML: html_body_scorp
sub html_body_scorp {
	$tr_bg_color=shift(@_);
	print <<HTML_BODY;
<tr bgcolor="$tr_bg_color">
<td align="center">
$num
</td>
<form action="$URL_SHOW" method="POST">
<input type="hidden" name="d_01" value="$search_word">
<input type="hidden" name="d_02" value="$sorted_filename">
<input type="hidden" name="d_03" value="$sorted_word">
<input type="hidden" name="d_04" value="$sorted_line">
<input type="hidden" name="d_05" value="$sorted_position">
<input type="hidden" name="d_06" value="$sorted_para">
<input type="hidden" name="uname" value="$uname">
<input type="hidden" name="passwd" value="$passwd">
<td align="center">
$sorted_word
</td>
<td align="center">
<span style="font-family: monospace">
$sorted_text
<span>
</td>
<td align="center">
<input type="submit" value="PARA">
</form>
</td>
</tr>
HTML_BODY
}

### Output Word Counter BODY by HTML: html_body_wc
sub html_body_wc {
	print <<HTML_BODY;
<tr bgcolor="$tr_bg_color">
<td align="center">
$num
</td>
<form action="$URL_SCORP" method="POST">
<input type="hidden" name="uname" value="$uname">
<input type="hidden" name="passwd" value="$passwd">
<input type="hidden" name="d_01" value="$wd">
<input type="hidden" name="d_02" value="$dir_name">
<input type="hidden" name="d_03" value="$sort">
<td align="center">
$wd
</td>
<td align="center">
$fq
</td>
<td align="center">
<input type="submit" value="SEARCH">
</form>
</td>
</tr>
HTML_BODY
}

### Output No Result Message: html_noresult
sub html_noresult {
	print <<HTML_BODY;
<td align="center">
No Result... Try Other Word(s).
</td>
HTML_BODY
}

### Output Footer by HTML: html_footer
sub html_footer {
	print <<HTML_BODY;
</tr>
</tbody>
</table>
</center>
<br>
<div style="text-align:center;font-weight:bold;">
<a href="$URL_SCORP_TOP">
Back to "Search" page
</a>
</div>
</form>
<hr>
<div style="text-align: right; font-size: x-large;font-weight: bold;">
SCORP powered by Perl and Apahce<br>
<a href="http://www.perl.org/" target="_blank"><img src="http://www.perl.org/simages/lcamel.gif" width="50" height="50"></a>
<a href="http://httpd.apache.org/" target="_blank"><img src="http://httpd.apache.org/images/apache_pb.gif"></a>
</div>
</body>
</html>
HTML_BODY
}
